from risotto.utils import multi_function as _multi_function
from rougail.utils import normalize_family
from tiramisu import valid_network_netmask, valid_ip_netmask, valid_broadcast, valid_in_network, valid_not_equal, calc_value, calc_value_property_help


@_multi_function
def risotto_providers_global(value, suffix=None):
    if suffix is not None:
        return value[int(suffix)]
    return value


@_multi_function
def risotto_flatten_values(multi, *args, follower_index=None):
    values = []
    #if follower_index is None:
    #    for arg in args:
    #        if isinstance(arg, list):
    #            values.extend(arg)
    #        else:
    #            values.append(arg)
    #else:
    values = args
    if follower_index is not None and len(values) > follower_index:
        values = values[follower_index]
    elif not multi:
        if not values:
            values = None
        if len(values) == 1:
            values = values[0]
    return values


@_multi_function
def risotto_flatten_values_client(multi, *args):
    values = []
    for arg in args:
        if isinstance(arg, list):
            values.extend(arg)
        else:
            values.append(arg)
    if not multi:
        if not values:
            values = None
        if len(values) == 1:
            values = values[0]
    return values


@_multi_function
def risotto_dyn_values(suffix, unique, multi, follower_index=None, **kwargs):
    values = kwargs.get(normalize_family(suffix), [] if multi else None)
    if not multi and follower_index is not None and isinstance(values, list) and len(values) > follower_index:
        values = values[follower_index]
    if isinstance(values, list) and unique:
        values_ = []
        for val in values:
            if val not in values_:
                values_.append(val)
        values = values_
    return values
